
##     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
##     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

##     This library is free software; you can redistribute it and/or modify it
##     under the terms of the GNU Lesser General Public License as published by the
##     Free Software Foundation; either version 2.1 of the License, or (at your
##     option) any later version.

##     This library is distributed in the hope that it will be useful, but WITHOUT
##     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
##     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
##     for more details.

##     You should have received a copy of the GNU Lesser General Public License
##     along with this library; if not, write to the Free Software Foundation,
##     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
##     http://www.gnu.org/licenses/lgpl.html

##     Author Contact Information:
##     Jim Sethna      
##     sethna@lassp.cornell.edu  
##     117 Clark Hall
##     Cornell University
##     Ithaca, NY 14850

# DMSystem/__init__.py  --  interface to the DMSystem stuff


# import the swigged module into this namespace

from DMSystem_DMSystem import *

# Replace the DoubleMatrix with an extended one
_OriginalDoubleMatrix = DoubleMatrix
del DoubleMatrix
class DoubleMatrix(_OriginalDoubleMatrix):
    """The 3*N DMMatrix of Floats."""

    def __init__(self, *args, **kargs):
        args = tuple([self] + list(args))
        apply(_OriginalDoubleMatrix.__init__, args, kargs)

    def Attach(self, branch):
        if branch.thisown != 1:
            raise ValueError, "Cannot attach an an object that is not owned by Python."
        # Do the attach in the C++ code
        retval = _OriginalDoubleMatrix.Attach(self, branch)
        # Now C++ owns the attached object
        branch.thisown = 0
        return retval
