/*
 * SimQA: Copyright (C) Jakob Schiotz 1996, 1997
 *
 * IBM POWER2 optimized vector library:
 * r = r + a * b * c
 */

#include "vectools.h"

/* r[] = r[] + a[] * b[] * c */
void vec_self_add_mul_mul_scal(double *res, const double *a, const double *b, double c,
			       int n)
{
    int i, limit;
    double a0, a1, a2, a3, a4, a5, a6, a7;
    double b0, b1, b2, b3, b4, b5, b6, b7;
    double s0, s1, s2, s3, s4, s5, s6, s7;

    limit = n-7;
    for (i = 0; i < limit; i+=8)
    {
	a0 = a[i];
	a1 = a[i+1];
	a2 = a[i+2];
	a3 = a[i+3];
	a4 = a[i+4];
	a5 = a[i+5];
	a6 = a[i+6];
	a7 = a[i+7];
	b0 = b[i];
	b1 = b[i+1];
	b2 = b[i+2];
	b3 = b[i+3];
	b4 = b[i+4];
	b5 = b[i+5];
	b6 = b[i+6];
	b7 = b[i+7];
	s0 = res[i];
	s1 = res[i+1];
	s2 = res[i+2];
	s3 = res[i+3];
	s4 = res[i+4];
	s5 = res[i+5];
	s6 = res[i+6];
	s7 = res[i+7];
	res[i] = a0 * b0 * c + s0;
	res[i+1] = a1 * b1 * c + s1;
	res[i+2] = a2 * b2 * c + s2;
	res[i+3] = a3 * b3 * c + s3;
	res[i+4] = a4 * b4 * c + s4;
	res[i+5] = a5 * b5 * c + s5;
	res[i+6] = a6 * b6 * c + s6;
	res[i+7] = a7 * b7 * c + s7;
    }
    for (i = n - n % 8; i < n; i++)
    {
	a0 = a[i];
	b0 = b[i];
	s0 = res[i];
	res[i] = a0 * b0 * c + s0;
    }
}

