/*
 * SimQA: Copyright (C) Jakob Schiotz 1996, 1997
 *
 * IBM POWER2 optimized vector library:
 * Creates two vectors of gaussian-distributed random number
 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>

#include "vectools.h"
#include "random.h"

#define TWOPI 6.28318530718

/* Calculate two vectors of random numbers.  Should be vectorized! */
/* P.t. does not use temporary storage */
void vec_gauss_rnd2(double *gr1, double *gr2, double *tmp1, double *tmp2,
		    int n)
{
    int i;
    double r1, r2, t;

    for (i = 0; i < n; i++)
    {
	r1 = ran2(0);
	r2 = TWOPI * ran2(0);
	t = sqrt(-2.0 * log(r1));
	gr1[i] = t * cos(r2);
	gr2[i] = t * sin(r2);
    }
}

