// SprintString.h interface for the SprintString class
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#ifndef _SPRINT_STRING_H_
#define _SPRINT_STRING_H_

#include "DMFirstHeader.h"
#include <string>
#include "DigitalMaterial.h"

//! A std::string derivative to construct sprintf strings on the stack.
/*!	This class is our answer to the difficulties using sstream or 
	stringstream on various platforms.  It lets you make a sprintf
	kind of string on the stack.

	\author ajd27
	\date 18 Feb 2001
	*/
class SprintString : public std::string {
	static const int BufferCnt;
	static char threadUnsafeBuffer[];
public:
	SprintString( const char* sMessage, ... );
};

#endif // _SPRINT_STRING_H_
