
//     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
//     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

//     This library is free software; you can redistribute it and/or modify it
//     under the terms of the GNU Lesser General Public License as published by the
//     Free Software Foundation; either version 2.1 of the License, or (at your
//     option) any later version.

//     This library is distributed in the hope that it will be useful, but WITHOUT
//     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
//     for more details.

//     You should have received a copy of the GNU Lesser General Public License
//     along with this library; if not, write to the Free Software Foundation,
//     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
//     http://www.gnu.org/licenses/lgpl.html

//     Author Contact Information:
//     Jim Sethna      
//     sethna@lassp.cornell.edu  
//     117 Clark Hall
//     Cornell University
//     Ithaca, NY 14850


// This pair of typemaps allows you to use std::string& args
// to a function  AJD
%typemap(in) std::string *, const std::string *, std::string &, const std::string & {
	if (PyString_Check($input)==0) { PyErr_SetString(PyExc_RuntimeError, "Arg was not a string."); return NULL; }
	$1 = new std::string(PyString_AsString($input));
}

// This typemap cleans up the new() above.
%typemap(freearg) std::string *, const std::string * {
	delete ($1);
}

%typemap(in) std::string, const std::string {
	if (PyString_Check($input)==0) { PyErr_SetString(PyExc_RuntimeError, "Arg was not a string."); return NULL; }
	$1 = std::string(PyString_AsString($input));
}


// This typemap allows you to return a std::string
%typemap(out) std::string, const std::string {
	$result = PyString_FromString($1.c_str());
}

// This typemap allows you to return a std::string *
%typemap(out) std::string*, const std::string* {
	$result = PyString_FromString($1->c_str());
}

