// ParallelAtomsInitializer.h: interface for the ParallelAtomsInitializer class.
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#ifndef PARALLELATOMSINITIALIZER_H
#define PARALLELATOMSINITIALIZER_H

#include "DigitalMaterial.h"

#include "AtomsInitializer.h"

class ParallelAtomsInitializer : public AtomsInitializer  
{
public:
    ParallelAtomsInitializer(AtomsInitializer *initializer);
    virtual ~ParallelAtomsInitializer() {}

    //! This step actually creates the classes while others set up the cretaion.
    void Create(ListOfAtoms *atoms);

    //! Rough center (for graphics)
    const double *GetCenter() const {return initializer->GetCenter();}

    //! Rough size (for graphics)
    double GetMaxSize() const {return initializer->GetMaxSize();}

private:
    AtomsInitializer *initializer;
};

#endif // !defined(AFX_PARALLELATOMSINITIALIZER_H__BEDCC431_0AE2_45E6_9779_80767C927109__INCLUDED_)
