
%%     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
%%     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

%%     This library is free software; you can redistribute it and/or modify it
%%     under the terms of the GNU Lesser General Public License as published by the
%%     Free Software Foundation; either version 2.1 of the License, or (at your
%%     option) any later version.

%%     This library is distributed in the hope that it will be useful, but WITHOUT
%%     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
%%     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
%%     for more details.

%%     You should have received a copy of the GNU Lesser General Public License
%%     along with this library; if not, write to the Free Software Foundation,
%%     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
%%     http://www.gnu.org/licenses/lgpl.html

%%     Author Contact Information:
%%     Jim Sethna      
%%     sethna@lassp.cornell.edu  
%%     117 Clark Hall
%%     Cornell University
%%     Ithaca, NY 14850


%typemap(python, in) double **epsilon, double **sigma
{
	$1 = new double*[DIMENSION];
	for(int a = 0; a < DIMENSION; ++a)
		$1[a] = new double[DIMENSION];
	if(PyList_Check($input))
	{
		PyObject *row;
		for(int i=0;i<2;++i)
		{
			row = PyList_GetItem($input,i);
			assert(PyList_Check(row));
			for(int j = 0; j < 2; ++j)
			{
				PyObject *item = PyList_GetItem(row, j);
				assert(PyFloat_Check(item));
				$1[i][j] = PyFloat_AsDouble(item);
			
			}
		}
	}
	else
	{
		PyErr_SetString(PyExc_TypeError,"not a list nor an array");
		return NULL;
	}
}

%typemap(python, freearg) double **epsilon
{
	for(int a = 0; a < DIMENSION; ++a)
		delete $1[a];
	delete $1;

}