
//     Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
//     Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

//     This library is free software; you can redistribute it and/or modify it
//     under the terms of the GNU Lesser General Public License as published by the
//     Free Software Foundation; either version 2.1 of the License, or (at your
//     option) any later version.

//     This library is distributed in the hope that it will be useful, but WITHOUT
//     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//     FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
//     for more details.

//     You should have received a copy of the GNU Lesser General Public License
//     along with this library; if not, write to the Free Software Foundation,
//     Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
//     http://www.gnu.org/licenses/lgpl.html

//     Author Contact Information:
//     Jim Sethna      
//     sethna@lassp.cornell.edu  
//     117 Clark Hall
//     Cornell University
//     Ithaca, NY 14850


%{
#include "CopySubset.h"
#include "IncrementalMinimizer.h"
#include "NotchMaker.h"
#include "WedgeMaker.h"
#include "OverlapPruner.h"
#include "SliceAtomsLocator.h"
#include "SphereAtomsLocator.h"
#include "RectangleAtomsLocator.h"
#include "Translator.h"
#include "UndercoordinatedPruner.h"
%}

%include "CopySubset.h"

%nodefault Transformer;
class Transformer
{
public:
	void Transform(ListOfAtoms *atoms);
};

%include "OverlapPruner.h"

%nodefault VoidMaker;
class VoidMaker : public Transformer{};

%include "NotchMaker.h"
%include "WedgeMaker.h"
%include "UndercoordinatedPruner.h"

/* Note: IncrementalMinimizer calls the Lapack function dgelsd which isn't included in all Lapack versions (it's relatively new)*/
%include "IncrementalMinimizer.h"
%nodefault AtomsLocator;
class AtomsLocator {};
%include "RectangleAtomsLocator.h"
%include "SliceAtomsLocator.h"
%include "SphereAtomsLocator.h"

%include "Translator.h"

/* ElasticField Transformers are in a separate file because there are many of them*/
%include "ElasticFieldTransformers.i"
