

/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/
#ifndef _DIALOGBUILDER_H
#define _DIALOGBUILDER_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DialogBuilder.h : header file
//

#include "DialogPacker.h"	// My packer
#include "Introspective.h"
#include "MDSimulation.h"

class Thread;


/////////////////////////////////////////////////////////////////////////////
// DialogBuilder dialog

/*! \ingroup windows */
class DialogBuilder : public CDialog
{

private:
	// XXX need to have a singleton idd_user base class to store these!
//	static const UINT idd_user_base;		// At least should be const! How do I initialize it?
//	static UINT idd_current_user_number;
	// Assign own identification number to dialog box class
//	const UINT IDD;

// Construction
public:
	DialogBuilder(MDSimulation *pSim, Thread *simThread, CWnd* pParent = NULL);   // non-standard constructor: XXX should pass handles

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
public:
	virtual int DoModal_DM(Introspective * pIntrospective);
	int GetMaximumNumberOfFieldsPerArray() const {return maxNumberOfFieldsPerArray;}
	void SetMaximumNumberOfFieldsPerArray(int max) {maxNumberOfFieldsPerArray = max;}

protected:
	// Don't know if this is important?
	DECLARE_MESSAGE_MAP()

private:
	DialogPacker dialog_template_packed;
	// XXX Pass handle to doc instead
	MDSimulation *pSim;
	Thread *simThread;

	// Values and IDs for local variables
	std::vector<int> m_integer;
	std::vector<UINT> id_integer;
	std::vector<double> m_double;
	std::vector<UINT> id_double;

	// Value and ID arrays for local arrays
	// XXX Only 1-D arrays supported for now
	std::vector< std::vector<int> > m_integer_array;
	std::vector< std::vector<UINT> > id_integer_array;
	std::vector< std::vector<double> > m_double_array;
	std::vector< std::vector<UINT> > id_double_array;

	int maxNumberOfFieldsPerArray;	// To avoid large arrays
	void ReleaseIDs(std::vector<UINT>& vec);
};

#endif // !defined(_DIALOGBUILDER_H)
