// DialogPacker.cpp: implementation of the DialogPacker class.
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#include "stdafx.h"
#include "MD.h"
#include "DialogPacker.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DialogPacker::DialogPacker()
{
	SetDlgTemplate(DS_MODALFRAME | WS_POPUP | WS_CAPTION | WS_SYSMENU,
								0,10,10,400,200);
	SetFontInfoA(8,"MS Sans Serif");
	SetCaption(_T("Dialog Packer Default Caption"));
}

DialogPacker::~DialogPacker()
{

}

void * DialogPacker::LockTemplate()
{
	int i = controlList.GetCount();

	WORD dialogWidth = wcslen(GetCaption()) * 4 + 30;	// Dialog-box coordinates = 4 per char
	WORD dialogHeight = 0;
	
	// controlList is a CObList of controls. We iterate over this list, packing the
	// controls vertically.
	if (!controlList.IsEmpty())
	{	
		CDlgTempl::CDlgItemTempl* control;
		for (POSITION pos = controlList.GetHeadPosition(); pos != NULL; )
		{
			control = (CDlgTempl::CDlgItemTempl*) controlList.GetNext(pos);
			// Positions overwritten			CPoint controlPosition = control->GetPosition();
			CSize controlSize = control->GetSize();
			
			control->SetPosition(0, dialogHeight);
			dialogHeight += (WORD) controlSize.cy;
			if (dialogWidth < controlSize.cx) dialogWidth = (WORD) controlSize.cx;
		}
	}

	// We now set the size of the box

	SetSize(dialogWidth, dialogHeight);

	// Change all controls to the same width

	if (!controlList.IsEmpty())
	{	
		CDlgTempl::CDlgItemTempl* control;
		for (POSITION pos = controlList.GetHeadPosition(); pos != NULL; )
		{
			control = (CDlgTempl::CDlgItemTempl*) controlList.GetNext(pos);
			// Positions overwritten			CPoint controlPosition = control->GetPosition();
			CSize controlSize = control->GetSize();
			
			control->SetSize(dialogWidth, (int) controlSize.cy);
		}
	}


	return CDlgTempl::LockTemplate();
}

void DialogPacker::SetSize(WORD cx, WORD cy)
{
	m_dlgTemplate.cx = cx;
	m_dlgTemplate.cy = cy;
}