// HWndStore.h: interface for the HWndStore class.
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#if !defined(AFX_HWNDSTORE_H__2B09727B_0C0C_48AF_A7F7_0B70B8671452__INCLUDED_)
#define AFX_HWNDSTORE_H__2B09727B_0C0C_48AF_A7F7_0B70B8671452__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afx.h>
#include "MDSimulation.h"
#include "MDDoc.h"
#include "MDView.h"

class CMDView;	// Avoids problems of recursion: CMDView refers to HWndStore which refers to CMDView.


// Store everything about the application, to pass to the working thread simThread.

class HWndStore : public CObject  
{
	DECLARE_DYNAMIC( HWndStore )

public:
	MDSimulation * pSim;
	CMDDoc * pcmdDoc;
	CMDView * pcmdView;
	HWND hwnd;
	HWndStore(HWND hwnd, CMDView* pcmdView, CMDDoc* pcmdDoc, MDSimulation* pSim);
	HWndStore();
	virtual ~HWndStore();

};


#endif // !defined(AFX_HWNDSTORE_H__2B09727B_0C0C_48AF_A7F7_0B70B8671452__INCLUDED_)
