// SimThreadController.h: interface for the SimThreadController class.
//
/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/

#if !defined(AFX_SIMTHREADCONTROLLER_H__28F57BBE_9E84_4D8A_A300_D7FD1EEA9EFF__INCLUDED_)
#define AFX_SIMTHREADCONTROLLER_H__28F57BBE_9E84_4D8A_A300_D7FD1EEA9EFF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxmt.h>	// for locking

class SimThreadController  
{
public:
	void ResumePaused();
	bool ThreadRunning();
	void Started();
	void Stopped();
	void Stop();
	void Paused();
	void Resume();
	void Pause();
	SimThreadController();
	virtual ~SimThreadController();
	bool PauseNow() const;
	bool StopNow() const;

private:
	CEvent threadResume;
	CEvent threadPaused;
	volatile bool pauseThread;
	CEvent threadStopped;
	volatile bool stopThread;
};

#endif // !defined(AFX_SIMTHREADCONTROLLER_H__28F57BBE_9E84_4D8A_A300_D7FD1EEA9EFF__INCLUDED_)
