/*********************************************************************************

    Copyright (C) 2005 Nicholas P. Bailey, Thierry Cretegny, Andrew J. Dolgert,
    Christopher R. Myers, Jakob Schiotz, James P. Sethna, Valerie R. Coffman

    This library is free software; you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License as published by the
    Free Software Foundation; either version 2.1 of the License, or (at your
    option) any later version.

    This library is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
    for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this library; if not, write to the Free Software Foundation,
    Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA or visit
    http://www.gnu.org/licenses/lgpl.html

    Author Contact Information:
    Jim Sethna      
    sethna@lassp.cornell.edu  
    117 Clark Hall
    Cornell University
    Ithaca, NY 14850

**********************************************************************************/
/*
 * vtkPropSource -- Drew Dolgert 14 Feb 2000
 * This class is responsible for providing a property collection
 * to a viewer.  The property collection is initialized by subclassing.
 */
#ifndef _VTKPROPSOURCE_H_
#define _VTKPROPSOURCE_H_

#include "vtkActorCollection.h"
#include "vtkVolumeCollection.h"
#include "vtkActor2DCollection.h"
#include <list>
class SphereListener;

/*! \ingroup windows */
class vtkPropSource
{
public:
	vtkPropSource();
	virtual ~vtkPropSource();
	virtual vtkPropCollection *GetProps() {return this->Props;};
	void AddListener(SphereListener *listener);
	void RemoveListener(SphereListener *listener);
protected:
	void Notify();
private:
	vtkPropCollection *Props;
	std::list<SphereListener*> listeners;
};
#endif //_VTKPROPSOURCE_H_