# -*- makefile -*-

# Use another name than ARCH (in makevars.mk), to prevent conflicts and
# to allow including both in arbitrary order.

INCLARCH = $(shell uname -m)


##################################################################
####                                                          ####
####               Compaq alpha running OSF1                  ####
####                                                          ####
##################################################################

ifeq ($(INCLARCH),alpha)


NETCDF_DIR = /usr/local/
BLAS_DIR   = /usr/local/
FFTW_DIR =

#########

NETCDF_INCLUDE = -I$(NETCDF_DIR)/include
NETCDF_LIB = -L$(NETCDF_DIR)/lib -lnetcdf

#BLAS_LIB = -L$(BLAS_DIR) -lblas
BLAS_LIB = -lcblas -lf77blas -llapack -latlas
BLAS_INCLUDE = -I$(BLAS_DIR)/include

FFTW_LIB = -L$(FFTW_DIR)/lib -lfftw
FFTW_INCLUDE = -I$(FFTW_DIR)/include 

endif  # ifeq ($(ARCH),alpha)




##################################################################
####                                                          ####
####                Intel i686 running Linux                  ####
####                                                          ####
##################################################################


ifeq ($(ARCH),i686)

NETCDF_DIR = /usr
BLAS_DIR = /usr/local/
FFTW_DIR = /usr/local/

#########

# NETCDF_INCLUDE = -I$(NETCDF_DIR)/include
NETCDF_LIB = -L$(NETCDF_DIR)/lib -lnetcdf
NETCDF_LIB = -lnetcdf

BLAS_LIB = -L$(BLAS_DIR)/lib -lblas
BLAS_INCLUDE = -I$(BLAS_DIR)/include

FFTW_LIB = -L$(FFTW_DIR)/lib -lfftw
FFTW_INCLUDE = -I$(FFTW_DIR)/include 


endif  # ifeq ($(ARCH),i686)

