# -*- makefile -*-
# The root directory of the src.  You have to set this so everything
# below can have absolute paths.
DMROOT = /home/val/work/DigitalMaterial
# Global settings
ARCH = $(shell arch)
# Global options (to add to any local ones)
OPTS = -O -DNDEBUG -fpermissive
# Our preferred shell.
SHELL = /bin/bash
# C compiler
CC = gcc
# C++ compiler
CXX = g++
# C preprocessor
CPP = $(CC) -E -MM
# Makes archives
AR = ar
# Fixes archive links for a library
RANLIB = ranlib
# Doxygen
DOXYGEN = /usr/local/pub/dm/bin/doxygen

# The path to swig. Set SWIG to nothing if you do not want to build the python package.
SWIG = /usr/bin/swig
SWIGOPT = -shadow
# Check for the next variables in swig's Makefile.template
CCSHARED        = -fpic
CXXSHARED       = $(CXX) -shared
PYTHON_INCLUDE  = -DHAVE_CONFIG_H -I/usr/include/python2.3 -I/usr/include/python2.3/Numeric
CPP_DLLIBS      =
SO              = .so


## Tell whether we build a parallel version. Note that it can also be run in serial in any case
DMPARALLEL = 1

# The compilers for mpi. Set this variable to nothing if you compile serial
#MPIcc = /afs/msc.cornell.edu/home/jsethna/rauscher/bin/mpicc
#MPICC = /afs/msc.cornell.edu/home/jsethna/rauscher/bin/mpiCC
#MPIcc = gcc -DLINUX -Dix86 -I/usr/local/lam/h -L/usr/local/lam/lib \
#	-ltstdio -ltrillium -largs -lt 

#MPICC = g++ -DLINUX -Dix86 -I/usr/local/lam/h -L/usr/local/lam/lib \
#	-ltstdio -ltrillium -largs -lt 
MPIcc = /usr/bin/mpicc
MPICC = /usr/bin/mpiCC


ifeq ($(DMPARALLEL),1)
CC = $(MPIcc)
CXX = $(MPICC)
OPTS += -DDMPARALLEL
endif

export DMROOT ARCH OPTS SHELL CC CXX CPP AR RANLIB DOXYGEN SWIG SWIGOPT CCSHARED CXXSHARED PYTHON_INCLUDE CPP_DLLIBS SO DMPARALLEL
